"use strict";

var _interopRequire = function (obj) { return obj && obj.__esModule ? obj["default"] : obj; };

Object.defineProperty(exports, "__esModule", {
  value: true
});

var concat = _interopRequire(require("stream-concat-promise"));

var crypto = _interopRequire(require("crypto"));

var Promise = _interopRequire(require("promise"));

var cryptoStream = function (create) {
  return function () {
    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return function (data, encoding) {
      var stream = create.apply(undefined, args);
      stream.end(data, encoding);
      return concat(stream);
    };
  };
};

var hash = cryptoStream(crypto.createHash);
exports.hash = hash;
var hmac = cryptoStream(crypto.createHmac);
exports.hmac = hmac;
var cipher = cryptoStream(crypto.createCipher);
exports.cipher = cipher;
var decipher = cryptoStream(crypto.createDecipher);
exports.decipher = decipher;
var randomBytes = Promise.denodeify(crypto.randomBytes);
exports.randomBytes = randomBytes;
